/* $XConsortium: wsm_funcs.h /main/5 1995/07/15 20:43:11 drk $ */
/*
 * COPYRIGHT NOTICE
 * Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 * ALL RIGHTS RESERVED (MOTIF).  See the file named COPYRIGHT.MOTIF
 * for the full copyright text.
 * 
 */
/*
 * HISTORY
 */

#ifndef _WSM_FUNCS_
#define _WSM_FUNCS_

/************************************************************
 *
 *  All function Prototypes for non static functions.
 *
 * Those that begin with _WSM are "private" for whatever that
 * is worth...
 *
 ************************************************************/

/*
 * disp.c
 */

WSMDispInfo * _WSMGetDispInfo(
Display *
);

WSMScreenInfo * _WSMGetScreenInfo(
Display *, int
);


void _WSMClearConfigScreenInfo(
Display *, int
);

WSMConfigFormatData * _WSMGetConfigFormat(
Display *, int, WSMConfigFormatType
);

Atom _WSMGetSelectionAtom(
Display *, int, WSMClientType
);

/*
 * free.c
 */

void FreeRequest(
WSMRequest *request
);

void FreeReply(
WSMReply *reply
);

/*
 * pack.c
 */

MessageData _WSMPackRequest(
Display *, int, WSMRequest *, unsigned long *, WSMErrorCode *
);

MessageData _WSMPackReply(
Display *, int, WSMReply *, unsigned long *
);

void _WSMUnpackRequest(
Display *, int, MessageData, unsigned long, WSMRequestType, WSMRequest *
);

void _WSMUnpackReply(
Display *, int, MessageData, unsigned long, WSMRequestType, WSMReply *
);

MessageData PackString(
MessageData, String
);

String UnpackString(
MessageData *
);

MessageData PackCARD32(
MessageData, CARD32
);

CARD32 UnpackCARD32(
MessageData *
);

/*
 * recv.c
 */

Boolean WSMDefaultOwnSelection(
Widget, WSMClientType, WSMRequestCallbackFunc, XtPointer
);

void WSMRegisterRequestCallback(
Display *, int, WSMRequestCallbackFunc, XtPointer
);

Boolean WSMIsKnownTarget(
Widget, Atom
);

Atom * GetTargetList(
Widget, Boolean, unsigned long *
);

Boolean WSMProcessProtoTarget(
Widget, Atom, XtPointer, unsigned long, 
int, Atom *, XtPointer *, unsigned long *, int *
);

/*
 * send.c
 */

Boolean WSMSendMessage(
Widget, WSMClientType, WSMRequest *, WSMReplyCallbackFunc, XtPointer
);

/*
 * utils.c
 */

String _WSMReqTypeToName(
WSMRequestType
);

WSMRequestType _WSMTargetToReqType(
Display *, Atom
);

Atom _WSMReqTypeToTarget(
Display *, WSMRequestType
);

Boolean _WSMRequiresConfigFormat(
WSMRequestType
);

WSMConfigFormatType _WSMGetConfigFormatType(
Window
);

WSMAttribute * _WSMGetMatchingAttr(
XrmQuark, WSMConfigFormatData *
);

WSMWinData * _WSMGetMatchingWinData(
WSMWinData *, int, XrmQuark
);

#endif /* DO NOT ADD ANYTHING AFTER THIS LINE */
