/*
 *  @OSF_COPYRIGHT@
 *  COPYRIGHT NOTICE
 *  Copyright (c) 1990, 1991, 1992, 1993 Open Software Foundation, Inc.
 *  ALL RIGHTS RESERVED (MOTIF). See the file named COPYRIGHT.MOTIF for
 *  the full copyright text.
*/
/*
 * HISTORY
*/
/*   $XConsortium: CxxXmString.h /main/4 1995/07/13 18:31:09 drk $ */

// Wrapper for XmString objects

class XmCxxString {
private:
  XmString	internal;
public:
      // Constructors
  XmCxxString(const char* str) { 
    internal = XmStringCreateLocalized((String) str); 
  };
  XmCxxString(XmCxxString &str) { internal = XmStringCopy(str.internal); }
  XmCxxString(XmString str) { internal = str; }
  XmCxxString() { internal = XmStringCreateLocalized((String) ""); }
  static XmCxxString& Separator() {
    XmCxxString *n;
    n = new XmCxxString(XmStringSeparatorCreate());
    return *n;
  }
      // Destructor
  ~XmCxxString() { XmStringFree(internal); }
      // Operators + (concat), = and ==
  XmCxxString& operator=(const char *s) {
    XmStringFree(internal);
    internal = XmStringCreateLocalized((String) s);
    return *this;
  }
  XmCxxString& operator=(const XmString s) {
    XmStringFree(internal);
    internal = s;
    return *this;
  }
  XmCxxString& operator=(const XmCxxString &s) {
    XmStringFree(internal);
    internal = XmStringCopy(s.internal);
    return *this;
  }
  friend Boolean operator== (XmCxxString &x, XmCxxString &y) {
    return XmStringCompare(x.internal, y.internal);
  }
  friend XmCxxString& operator+(XmCxxString &x, XmCxxString &y);
  friend XmCxxString& operator+(XmCxxString &x, char *y);
  operator XmString() { return internal; }
      // Accessors and Functions
  Dimension 	baseline(XmRenderTable tab);
  Boolean 	empty() { return XmStringEmpty(internal); }
  void 		draw(Widget w, XmRenderTable r, GC gc, 
		     Position x, Position y, Dimension width, 
		     unsigned char alignment, unsigned char layout_dir,
		     XRectangle *clip);
  void 		draw(Display *d, Window w, XmRenderTable r, GC gc, 
		     Position x, Position y, Dimension width, 
		     unsigned char alignment, unsigned char layout_dir,
		     XRectangle *clip);
  void		extents(XmRenderTable r, Dimension *w, Dimension *h);
  Boolean	hasSubstring(XmCxxString& ss) {
    return XmStringHasSubstring(internal, ss.internal);
  }
  int		length() { return XmStringLength(internal); }
  int		lineCount() { return XmStringLineCount(internal); }
};



